// AcceptAndAddDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MessengerClient.h"
#include "AcceptAndAddDlg.h"

#include "MessengerClientDoc.h"
#include "MessagePacket.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAcceptAndAddDlg dialog


CAcceptAndAddDlg::CAcceptAndAddDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcceptAndAddDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcceptAndAddDlg)
	m_strFriendMsg = _T("");
	//}}AFX_DATA_INIT
}

CAcceptAndAddDlg::CAcceptAndAddDlg(CMessengerClientDoc *pDoc, CWnd* pParent /*= NULL*/)   // additional constructor
	: CDialog(CAcceptAndAddDlg::IDD, pParent)
{
	m_strFriendMsg = _T("");
	m_pParent = pDoc;
	m_pMsg = new CMessagePacket();
}

CAcceptAndAddDlg::~CAcceptAndAddDlg()
{
	delete(m_pMsg);
}

void CAcceptAndAddDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcceptAndAddDlg)
	DDX_Text(pDX, IDC_FRIENDS_MESSAGE, m_strFriendMsg);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAcceptAndAddDlg, CDialog)
	//{{AFX_MSG_MAP(CAcceptAndAddDlg)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_JUST_ACCEPT, OnJustAccept)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAcceptAndAddDlg message handlers

void CAcceptAndAddDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	
}



/**************************************************************************/
// Method Name	: OnOK 
// Description	: Called when user clicks 'Accept and Add' button
// Inputs		: None
// Output		: Sends notification message to the sender, and closes the dialog
// Returns		: void
/**************************************************************************/
void CAcceptAndAddDlg::OnOK() 
{
	// Prepare a message packet to be sent as 'Accept and Add' to server
	m_pMsg->m_strFrom = m_pParent->m_UserName;
	m_pMsg->m_strReasonFlag = "AFA";
	m_pMsg->m_strMessageBody = "User " + m_pMsg->m_strFrom + " has accepted your invitation and also has added you to his/her friends list";

	m_pParent->SendMessagePacket(*m_pMsg);

	Sleep(200);
	
	
	CDialog::OnOK();
}



/**************************************************************************/
// Method Name	: OnJustAccept 
// Description	: Called when user clicks 'Just Accept' button
// Inputs		: None
// Output		: Sends notification message to the sender, and closes the dialog
// Returns		: void
/**************************************************************************/
void CAcceptAndAddDlg::OnJustAccept() 
{
	// Prepare a message packet to be sent as 'Accept and Add' to server
	m_pMsg->m_strFrom = m_pParent->m_UserName;
	m_pMsg->m_strReasonFlag = "AFJ";
	m_pMsg->m_strMessageBody = "User " + m_pMsg->m_strFrom + " has accepted your invitation";

	m_pParent->SendMessagePacket(*m_pMsg);

	Sleep(200);
	
	CDialog::OnOK();
	
}



/**************************************************************************/
// Method Name	: OnCancel 
// Description	: Called when user clicks 'Reject' button
// Inputs		: None
// Output		: Sends notification message to the sender, and closes the dialog
// Returns		: void
/**************************************************************************/
void CAcceptAndAddDlg::OnCancel() 
{
	// Prepare a message packet to be sent as 'Accept and Add' to server
	m_pMsg->m_strFrom = m_pParent->m_UserName;
	m_pMsg->m_strReasonFlag = "AFD";

	m_pParent->SendMessagePacket(*m_pMsg);

	Sleep(200);
	
	CDialog::OnCancel();
}
