// AddAFriend.cpp : implementation file
//

#include "stdafx.h"
#include "MessengerClient.h"
#include "AddAFriend.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "MessengerClientDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CAddAFriend dialog


CAddAFriend::CAddAFriend(CWnd* pParent /*=NULL*/)
	: CDialog(CAddAFriend::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddAFriend)
	m_strMessage = _T("");
	m_strFriendID = _T("");
	//}}AFX_DATA_INIT
}

CAddAFriend::CAddAFriend(CMessengerClientDoc *pDoc, CWnd* pParent /*= NULL*/)   // additional constructor
	: CDialog(CAddAFriend::IDD, pParent)
{
	m_strFriendID = _T("");
	m_strMessage = _T("");
	m_pParent = pDoc;
}


void CAddAFriend::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddAFriend)
	DDX_Text(pDX, IDC_MESSAGE, m_strMessage);
	DDX_Text(pDX, IDC_FRIEND_ID, m_strFriendID);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddAFriend, CDialog)
	//{{AFX_MSG_MAP(CAddAFriend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddAFriend message handlers

/**************************************************************************/
// Method Name	: OnOK
// Description	: Called when user clicks 'Add the Friend' button
// Inputs		: None
// Output		: Sends add friend message to the friend and shows the
//				  notification to sender
// Returns		: void
/**************************************************************************/
void CAddAFriend::OnOK() 
{
	// Get the data from screen into the vars
	UpdateData(TRUE);	

	// Check the data
	if(m_strFriendID.GetLength() == 0)
	{
		::AfxMessageBox("Please enter a friend ID");
		return;
	}
	// Create a message packet
	CMessagePacket msg;

	msg.m_strFrom	= m_pParent->m_UserName;
	msg.m_strTo		= m_strFriendID;
	msg.m_strMessageBody = m_strMessage;
	msg.m_strReasonFlag = "AF";			// Add friend flag

	// Send the message
	m_pParent->SendMessagePacket(msg);
	
	::AfxMessageBox("A message has been sent to the user asking for his permission");
	
	CDialog::OnOK();
}



/**************************************************************************/
// Method Name	: OnInitDialog
// Description	: Dialog initialization
// Inputs		: None
// Output		: Calls base class method and sets focus on friend's id field
// Returns		: void
/**************************************************************************/
BOOL CAddAFriend::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Set focus on the new friend's id edit box
	GetDlgItem(IDC_FRIEND_ID)->SetFocus();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
