//////////////////////////////////////////////////////////////////////
// CommonDialogElements.h:
// interface for the CCommonDialogElements class.
// My original idea was to have this class as the base class for all the
// dialogs that access sockets, But since only the Doc class holds all
// references to sockets, this class has become redendent. But still I ve
// kept it like this in the hope that someone will find an application for
// it
//
// This class contains some key socket functionality. Be careful while
// touching the code here
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMONDIALOGELEMENTS_H__9308BE44_6EF8_11D6_8144_0001031200E7__INCLUDED_)
#define AFX_COMMONDIALOGELEMENTS_H__9308BE44_6EF8_11D6_8144_0001031200E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include<fstream.h>

#include "MessagePacket.h"
#include "MessengerClientSocket.h"

class CCommonDialogElements  
{
public:
	CCommonDialogElements();
	virtual ~CCommonDialogElements();

public:
	CMessengerClientSocket *m_pSocket;	// Socket communicating with server
	// Streams for passing data to and fro server
	CArchive *m_pArIn;					
	CArchive *m_pArOut;
	CSocketFile *m_pSocketFile;

	// Message packet for carrying the data
	CMessagePacket *m_pMsgPacket;

	// This is true when client is CONNECTED to server
	BOOL m_bServerOnline;

public:
	virtual BOOL Connect2ServerSocket();
	virtual bool SendMessagePacket(CMessagePacket& msgPacket);
	virtual bool ReceiveMessagePacket();
	virtual bool ProcessMessagePacket() = 0;
	virtual bool GetConfigData();

public:
	// Socket Specifications will be stored here
	int						m_nPortNum;
	CString					m_strIPAddress;
};

#endif // !defined(AFX_COMMONDIALOGELEMENTS_H__9308BE44_6EF8_11D6_8144_0001031200E7__INCLUDED_)
