// LoginPReferences.cpp : implementation file
//

#include "stdafx.h"
#include "MessengerClient.h"
#include "LoginPReferences.h"
#include "MessengerClientDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLoginPreferences property page

IMPLEMENT_DYNCREATE(CLoginPreferences, CPropertyPage)

CLoginPreferences::CLoginPreferences() : CPropertyPage(CLoginPreferences::IDD)
{
	//{{AFX_DATA_INIT(CLoginPreferences)
	m_bAutoLogin = FALSE;
	m_strPassword = _T("");
	m_bRememberLogin = FALSE;
	m_strUserName = _T("");
	//}}AFX_DATA_INIT
	bDirty = false;
}

CLoginPreferences::~CLoginPreferences()
{
}

void CLoginPreferences::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoginPreferences)
	DDX_Check(pDX, IDC_AUTO_LOGIN, m_bAutoLogin);
	DDX_Text(pDX, IDC_PASSWORD, m_strPassword);
	DDX_Check(pDX, IDC_REMEMBER_LOGIN, m_bRememberLogin);
	DDX_Text(pDX, IDC_USERNAME, m_strUserName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoginPreferences, CPropertyPage)
	//{{AFX_MSG_MAP(CLoginPreferences)
	ON_EN_CHANGE(IDC_USERNAME, OnChangeUsername)
	ON_EN_CHANGE(IDC_PASSWORD, OnChangePassword)
	ON_BN_CLICKED(IDC_REMEMBER_LOGIN, OnRememberLogin)
	ON_BN_CLICKED(IDC_AUTO_LOGIN, OnAutoLogin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoginPreferences message handlers




/**************************************************************************/
// Method Name	: OnChangeUsername
// Description	: Called when user makes changes to original user name
// Inputs		: None
// Output		: Notes the new user name in dialog's local data
//				  Sets the modified bit, so that Apply button is enabled
// Returns		: void
/**************************************************************************/
void CLoginPreferences::OnChangeUsername() 
{
	// Take data from screen to this var
	UpdateData(TRUE);

	// Copy this change to the property sheet
	m_pParent->m_pPreferencesDlg->m_Preferences.m_UserName = m_strUserName;

	SetModified();
	bDirty = true;
}



/**************************************************************************/
// Method Name	: OnChangePassword
// Description	: Called when user makes changes to original password
// Inputs		: None
// Output		: Notes the new password in dialog's local data
//				  Sets the modified bit, so that Apply button is enabled
// Returns		: void
/**************************************************************************/
void CLoginPreferences::OnChangePassword() 
{
	// Take data from screen to this var
	UpdateData(TRUE);

	// Copy this change to the property sheet
	m_pParent->m_pPreferencesDlg->m_Preferences.m_Password = m_strPassword;

	SetModified();
	bDirty = true;
}



/**************************************************************************/
// Method Name	: OnChangePassword
// Description	: Called when user clicks Remember Login check box
// Inputs		: None
// Output		: Toggles the status of this check box in 
//				  the preferences of dialog's local data
//				  Sets the modified bit, so that Apply button is enabled
// Returns		: void
/**************************************************************************/
void CLoginPreferences::OnRememberLogin() 
{
	// Take data from screen to this var
	UpdateData(TRUE);

	if(m_bRememberLogin)
		m_pParent->m_pPreferencesDlg->m_Preferences.m_bRememberLogin = 1;
	else
		m_pParent->m_pPreferencesDlg->m_Preferences.m_bRememberLogin = 0;

	SetModified();
	bDirty = true;
}



/**************************************************************************/
// Method Name	: OnAutoLogin
// Description	: Called when user clicks Automatically Login check box
// Inputs		: None
// Output		: Toggles the status of this check box in 
//				  the preferences of dialog's local data
//				  Sets the modified bit, so that Apply button is enabled
// Returns		: void
/**************************************************************************/
void CLoginPreferences::OnAutoLogin() 
{
	// Take data from screen to this var
	UpdateData(TRUE);

	if(m_bAutoLogin)
		m_pParent->m_pPreferencesDlg->m_Preferences.m_bAutoLogin = 1;
	else
		m_pParent->m_pPreferencesDlg->m_Preferences.m_bAutoLogin = 0;

	SetModified();
	bDirty = true;
}



/**************************************************************************/
// Method Name	: OnAutoLogin
// Description	: Called when user clicks Apply button or OK button
// Inputs		: None
// Output		: Overwrites the application preferences with dialog
//				  local preferences data and reflects them in the application
//				  Calls base class method
// Returns		: TRUE - Success
//				  FALSE - otherwise
/**************************************************************************/
BOOL CLoginPreferences::OnApply() 
{
	if(bDirty)
	{
		// Copy all preferences from preferences property sheet to doc object
		m_pParent->m_Preferences = m_pParent->m_pPreferencesDlg->m_Preferences;

		// Call the doc class's apply function
		m_pParent->ApplyPreferenceChanges(LOGIN_PREFERENCES);
	}
	
	return CPropertyPage::OnApply();
}
