//////////////////////////////////////////////////////////////////////
// LoginPreferences.h: 
// interface for the CLoginPreferences class.
// This is one of the panes in Preferences Dialog (CPreferences class)
// This contains facility for changing the Login preferences. It allows user
// to store his/her login/password and autologin preferences.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOGINPREFERENCES_H__35BE9903_D093_11D6_819F_0001031200E7__INCLUDED_)
#define AFX_LOGINPREFERENCES_H__35BE9903_D093_11D6_819F_0001031200E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LoginPreferences.h : header file
//

class CMessengerClientDoc;
class CPreferences;

/////////////////////////////////////////////////////////////////////////////
// CLoginPreferences dialog

class CLoginPreferences : public CPropertyPage
{
	DECLARE_DYNCREATE(CLoginPreferences)

// Construction
public:
	CLoginPreferences();
	~CLoginPreferences();

// Dialog Data
	//{{AFX_DATA(CLoginPreferences)
	enum { IDD = IDD_LOGIN_PREFERENCES_TAB };
	BOOL	m_bAutoLogin;
	CString	m_strPassword;
	BOOL	m_bRememberLogin;
	CString	m_strUserName;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CLoginPreferences)
	public:
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	bool bDirty;
	// Generated message map functions
	//{{AFX_MSG(CLoginPreferences)
	afx_msg void OnChangeUsername();
	afx_msg void OnChangePassword();
	afx_msg void OnRememberLogin();
	afx_msg void OnAutoLogin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	CMessengerClientDoc *m_pParent;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LOGINPREFERENCES_H__35BE9903_D093_11D6_819F_0001031200E7__INCLUDED_)
