// MessagePacket.cpp: implementation of the CMessagePacket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MessagePacket.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMessagePacket::CMessagePacket()
{
	m_strFrom		= "";
	m_strTo			= "";
	m_strMessageBody= "";
	m_strReasonFlag	= "";
	m_MessageTime	= CTime::GetCurrentTime();
}


// Copy constructor
CMessagePacket::CMessagePacket(CMessagePacket& msg)
{
	m_strFrom		= msg.m_strFrom;
	m_strTo			= msg.m_strTo;
	m_strMessageBody= msg.m_strMessageBody;
	m_strReasonFlag	= msg.m_strReasonFlag;	
	m_MessageTime	= msg.m_MessageTime;
	m_iFontColor	= msg.m_iFontColor;
	m_iFontSize		= msg.m_iFontSize;
}


CMessagePacket::~CMessagePacket()
{
}



/**************************************************************************/
// Method Name	: Serialize()
// Description	: Sends/receives data to/from server thru archives
// Inputs		: CArchive
// Output		: Sends all data over the archive to server, if the archive
//				  is output, else receives data from server
// Returns		: void
/**************************************************************************/
void CMessagePacket::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_strFrom;
		ar << m_strTo;
		ar << m_strMessageBody;
		ar << m_strReasonFlag;
		ar << m_MessageTime;

		// Font characteristics
		ar << m_strFontFace;
		ar << m_iFontSize;
		ar << m_MessageFont.lfWidth;
		ar << m_MessageFont.lfEscapement;
		ar << m_MessageFont.lfOrientation;
		ar << m_MessageFont.lfWeight;
		ar << m_MessageFont.lfItalic;
		ar << m_MessageFont.lfUnderline;
		ar << m_MessageFont.lfStrikeOut;
		ar << m_MessageFont.lfCharSet;
		ar << m_MessageFont.lfOutPrecision;
		ar << m_MessageFont.lfClipPrecision;
		ar << m_MessageFont.lfQuality;
		ar << m_MessageFont.lfPitchAndFamily;
		ar << m_iFontColor;
	}
	else
	{
		ar >> m_strFrom;
		ar >> m_strTo;
		ar >> m_strMessageBody;
		ar >> m_strReasonFlag;
		ar >> m_MessageTime;

		// Font characteristics
		ar >> m_strFontFace;
		ar >> m_iFontSize;
		ar >> m_MessageFont.lfWidth;
		ar >> m_MessageFont.lfEscapement;
		ar >> m_MessageFont.lfOrientation;
		ar >> m_MessageFont.lfWeight;
		ar >> m_MessageFont.lfItalic;
		ar >> m_MessageFont.lfUnderline;
		ar >> m_MessageFont.lfStrikeOut;
		ar >> m_MessageFont.lfCharSet;
		ar >> m_MessageFont.lfOutPrecision;
		ar >> m_MessageFont.lfClipPrecision;
		ar >> m_MessageFont.lfQuality;
		ar >> m_MessageFont.lfPitchAndFamily;
		ar >> m_iFontColor;
	}
	m_msgList.Serialize(ar);
}
