//////////////////////////////////////////////////////////////////////
// MessagePacket.h: interface for the CMessagePacket class.
// This class is a sort of protocol between this client and server.
// Be very careful while touching this class. If anything is changed or
// added, make sure that the new data types are serializable and be sure
// to serialize them in Serialize() method. Also make sure that the 
// client and server versions of this class are exactly identical
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESSAGEPACKET_H__194D34E2_6E52_11D6_8143_0001031200E7__INCLUDED_)
#define AFX_MESSAGEPACKET_H__194D34E2_6E52_11D6_8143_0001031200E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MessengerClientSocket.h"

class CMessagePacket : public CObject  
{
public:
	CString m_strFrom;				// From party
	CString m_strTo;				// To party
	CString m_strMessageBody;		// Message
	CString m_strReasonFlag;		// For various combinations check
									// ProcessMessagePacket() method
									// in Doc class
	CStringList m_msgList;			// May be used for long string lists, e.g.
									// friend's list
	CTime		m_MessageTime;		// Time when message was sent
	LOGFONT		m_MessageFont;		// Font of the message
	CString		m_strFontFace;		// Font name
	int			m_iFontColor;		// Font color
	int			m_iFontSize;		// Font size
public:
	CMessagePacket();
	CMessagePacket(CMessagePacket& msg);
	virtual ~CMessagePacket();
	void Serialize(CArchive& ar);
};

#endif // !defined(AFX_MESSAGEPACKET_H__194D34E2_6E52_11D6_8143_0001031200E7__INCLUDED_)
