// MessengerClient.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MessengerClient.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MessengerClientDoc.h"
#include "MessengerClientView.h"
#include "ListPane.h"
#include "TextPane.h"
#include "OfflineMessagesWindow.h"
#include "SpeakWindow.h"
#include "SpeakWindowFrame.h"
#include "Splash.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientApp

BEGIN_MESSAGE_MAP(CMessengerClientApp, CWinApp)
	//{{AFX_MSG_MAP(CMessengerClientApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientApp construction

CMessengerClientApp::CMessengerClientApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMessengerClientApp object

CMessengerClientApp theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.

// {30B8B542-B68A-11D6-8185-0001031200E7}
static const CLSID clsid =
{ 0x30b8b542, 0xb68a, 0x11d6, { 0x81, 0x85, 0x0, 0x1, 0x3, 0x12, 0x0, 0xe7 } };

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientApp initialization




/**************************************************************************/
// Method Name	: InitInstance
// Description	: System defined method, this starts the app
// Inputs		: None
// Output		: Enables sockets functionality
//				  Enables OLE functionality
//				  Enables container functionality
//				  Enables 3D controls functionality
//				  Sets registry key as 'ShirishSoft'. This means all the client
//					keys will be places under HKEY_CURRENT_USER - Software - ShirishSoft
//				  Creates various Doc templates. Offline messages and Speak window templates
//					are stored at object level, as they use different frame windows than
//					the defaults.
//				  Automatically shows the login dialog
//				  Initializes Rich Edit functionality.
// Returns		: TRUE - Success
//				  FALSE - Otherwise
/**************************************************************************/
BOOL CMessengerClientApp::InitInstance()
{
	// CG: The following block was added by the Splash Screen component.
\
	{
\
		CCommandLineInfo cmdInfo;
\
		ParseCommandLine(cmdInfo);
\

\
		CSplashWnd::EnableSplashScreen(cmdInfo.m_bShowSplash);
\
	}
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	//SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	SetRegistryKey(_T("ShirishSoft"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_MESSENTYPE,
		RUNTIME_CLASS(CMessengerClientDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMessengerClientView));
	AddDocTemplate(pDocTemplate);

	// Connect the COleTemplateServer to the document template.
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template.
	m_server.ConnectTemplate(clsid, pDocTemplate, FALSE);

	// Register all OLE server factories as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleTemplateServer::RegisterAll();
		// Note: MDI applications register all server objects without regard
		//  to the /Embedding or /Automation on the command line.

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Check to see if launched as OLE server
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// Application was run with /Embedding or /Automation.  Don't show the
		//  main window in this case.
		return TRUE;
	}

	// When a server application is launched stand-alone, it is a good idea
	//  to update the system registry in case it has been damaged.
	m_server.UpdateRegistry(OAT_DISPATCH_OBJECT);
	COleObjectFactory::UpdateRegistryAll();

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	{	
		// Offline Messages List Pane
		// BLOCK: doc template registration
		// Register the document template.  Document templates serve
		// as the connection between documents, frame windows and views.
		// Attach this form to another document or frame window by changing
		// the document or frame class in the constructor below.
		CMultiDocTemplate* pNewDocTemplate = new CMultiDocTemplate(
			IDR_LISTPANE_TMPL,
			RUNTIME_CLASS(CMessengerClientDoc),		// document class
			//RUNTIME_CLASS(CMDIChildWnd),		// frame class
			RUNTIME_CLASS(COfflineMessagesFrameWnd),		// frame class
			RUNTIME_CLASS(CListPane));		// view class
		AddDocTemplate(pNewDocTemplate);
	}


	{	
		// Offline Messages Text and Buttons Pane
		// BLOCK: doc template registration
		// Register the document template.  Document templates serve
		// as the connection between documents, frame windows and views.
		// Attach this form to another document or frame window by changing
		// the document or frame class in the constructor below.
		CMultiDocTemplate* pNewDocTemplate = new CMultiDocTemplate(
			IDR_TEXTPANE_TMPL,
			RUNTIME_CLASS(CMessengerClientDoc),		// document class
			//RUNTIME_CLASS(CMDIChildWnd),		// frame class
			RUNTIME_CLASS(COfflineMessagesFrameWnd),		// frame class
			RUNTIME_CLASS(CTextPane));		// view class
		AddDocTemplate(pNewDocTemplate);
	}

	{	
		// Offline Messages Window
		// BLOCK: doc template registration
		// Register the document template.  Document templates serve
		// as the connection between documents, frame windows and views.
		// Attach this form to another document or frame window by changing
		// the document or frame class in the constructor below.
		pOfflineMessagesDocTemplate = new CMultiDocTemplate(
			IDR_OFFLINEMESSAGESWINDOW_TMPL,
			RUNTIME_CLASS(CMessengerClientDoc),		// document class
//			RUNTIME_CLASS(CMDIChildWnd),		// frame class
			RUNTIME_CLASS(COfflineMessagesFrameWnd),		// frame class
			RUNTIME_CLASS(COfflineMessagesWindow));		// view class
		AddDocTemplate(pOfflineMessagesDocTemplate);
	}

	{	
		// Speak Window
		// BLOCK: doc template registration
		// Register the document template.  Document templates serve
		// as the connection between documents, frame windows and views.
		// Attach this form to another document or frame window by changing
		// the document or frame class in the constructor below.
		pSpeakWindowDocTemplate = new CMultiDocTemplate(
			IDR_SPEAKWINDOW_TMPL1,
			RUNTIME_CLASS(CMessengerClientDoc),		// document class
			RUNTIME_CLASS(CSpeakWindowFrame),		// frame class
			RUNTIME_CLASS(CSpeakWindow));		// view class
		AddDocTemplate(pSpeakWindowDocTemplate);
	}

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(SW_SHOW);
	(CChildFrame *)pMainFrame->GetActiveFrame()->ShowWindow(SW_SHOWMAXIMIZED);
	pMainFrame->UpdateWindow();

	// Directly show the Login window
	CMainFrame *wnd = (CMainFrame *)::AfxGetMainWnd();
	wnd->ShowUserLoginDialog();

	// This is for enabling use of Rich Text controls in the app. If this is
	// not done, program will crash!
	::AfxInitRichEdit( );

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMessengerClientApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientApp message handlers


#include "SpeakWindow.h"
#include "TextPane.h"
#include "ListPane.h"
#include "OfflineMessagesWindow.h"
#include "Splash.h"

BOOL CMessengerClientApp::PreTranslateMessage(MSG* pMsg)
{
	// CG: The following lines were added by the Splash Screen component.
	if (CSplashWnd::PreTranslateAppMessage(pMsg))
		return TRUE;

	return CWinApp::PreTranslateMessage(pMsg);
}
