// MessengerClientView.cpp : implementation of the CMessengerClientView class
//

#include "stdafx.h"
#include "MessengerClient.h"

#include "MessengerClientDoc.h"
#include "MessengerClientView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientView

IMPLEMENT_DYNCREATE(CMessengerClientView, CFormView)

BEGIN_MESSAGE_MAP(CMessengerClientView, CFormView)
	//{{AFX_MSG_MAP(CMessengerClientView)
	ON_NOTIFY(NM_DBLCLK, IDC_ONLINE, OnDblclkOnline)
	ON_COMMAND(FRIEND_ADD_FRIEND, OnAddFriend)
	ON_COMMAND(ID_FILE_CHANGE_USER, OnFileChangeUser)
	ON_COMMAND(OFFLINE_MESSAGES, OnOfflineMessages)
	ON_COMMAND(ID_TOOLS_CHANGEPASSWORD, OnChangepassword)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_CHANGEPASSWORD, OnUpdateToolsChangepassword)
	ON_UPDATE_COMMAND_UI(FRIEND_ADD_FRIEND, OnUpdateAddFriend)
	ON_UPDATE_COMMAND_UI(OFFLINE_MESSAGES, OnUpdateMessages)
	ON_COMMAND(ID_FILE_DISCONNECT, OnFileDisconnect)
	ON_UPDATE_COMMAND_UI(ID_FILE_DISCONNECT, OnUpdateFileDisconnect)
	ON_UPDATE_COMMAND_UI(FRIEND_DELETE_FRIEND, OnUpdateDeleteFriend)
	ON_UPDATE_COMMAND_UI(FRIEND_SEARCH_FRIEND, OnUpdateSearchFriend)
	ON_COMMAND(FRIEND_DELETE_FRIEND, OnDeleteFriend)
	ON_UPDATE_COMMAND_UI(ID_FILE_CHANGE_USER, OnUpdateFileChangeUser)
	ON_COMMAND(ID_FILE_PREFERENCES, OnFilePreferences)
	ON_COMMAND(SEND_MESSAGE, OnMessage)
	ON_NOTIFY(TVN_SELCHANGED, IDC_ONLINE, OnSelchangedOnline)
	ON_WM_SIZE()
	ON_UPDATE_COMMAND_UI(SEND_MESSAGE, OnUpdateMessage)
	ON_COMMAND(ID_TOOLS_BLOCKEDUSERSLIST, OnToolsBlockeduserslist)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_BLOCKEDUSERSLIST, OnUpdateToolsBlockeduserslist)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientView construction/destruction

CMessengerClientView::CMessengerClientView()
	: CFormView(CMessengerClientView::IDD)
{
	//{{AFX_DATA_INIT(CMessengerClientView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_strSelFriend = "";
	m_bFirstTime = true;
}

CMessengerClientView::~CMessengerClientView()
{
}

void CMessengerClientView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMessengerClientView)
	DDX_Control(pDX, IDC_ONLINE, m_FriendsList);
	//}}AFX_DATA_MAP
}

BOOL CMessengerClientView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	
	//cs.style &= WS_OVERLAPPED | WS_SYSMENU | WS_BORDER|WS_MAXIMIZE;
	//cs.style |= WS_MAXIMIZE;

	return CFormView::PreCreateWindow(cs);
}

void CMessengerClientView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	ResizeParentToFit();

	// Store the doc pointer
	m_pDoc = GetDocument();

	// Registry settings about view will come into effect here
	// Set background color
	if(!m_pDoc->m_Preferences.m_iColor)
			m_pDoc->m_Preferences.m_iColor = DEFAULT_BACKGROUND_COLOR;

	m_FriendsList.SetBkColor(m_pDoc->m_Preferences.m_iColor);

	// Initialize friend's list headers
	InitFriendsList();

	// Adjust the controls on the form
	AdjustFormControls();
}

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientView printing

BOOL CMessengerClientView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMessengerClientView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMessengerClientView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CMessengerClientView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientView diagnostics

#ifdef _DEBUG
void CMessengerClientView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMessengerClientView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMessengerClientDoc* CMessengerClientView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMessengerClientDoc)));
	return (CMessengerClientDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMessengerClientView message handlers

/**************************************************************************/
// Method Name	: OnDblclkOnline
// Description	: Called when user double clicks on friend's list
// Inputs		: System defined
// Output		: Finds out which tree node is double clicked on
//				  If it's a friend's name, create a speak window for that friend
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnDblclkOnline(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Get the handle to the selected item
	HTREEITEM selFriend = m_FriendsList.GetSelectedItem();

	// If this is not an online friend's name, return
	int nImage = 0, nSelectedImage = 0;
	if(m_FriendsList.GetItemImage(selFriend, nImage, nSelectedImage))
	{
		if((nImage != ONLINE_FRIEND_IMAGE_INDEX) && (nImage != OFFLINE_FRIEND_IMAGE_INDEX))
			return;
	}
	
	// If user has clicked an online user's name, get that name
	CString strName = m_FriendsList.GetItemText(selFriend);

	// Create a new User window and send this info to the Doc class
	CreateASpeakWindow(strName, NULL, m_pDoc->m_Preferences.m_strFontFace, &m_pDoc->m_Preferences.m_Font, m_pDoc->m_Preferences.m_iFontColor, m_pDoc->m_Preferences.m_iFontSize);

	*pResult = 0;
}



/**************************************************************************/
// Method Name	: InitFriendsList
// Description	: Called when initializing a friend's list
// Inputs		: none
// Output		: Creates titles for tree branches of friends tree view
// Returns		: void
/**************************************************************************/
void CMessengerClientView::InitFriendsList()
{
	m_pDoc->m_hFriends	= m_FriendsList.InsertItem(TVIF_CHILDREN|TVIF_HANDLE |TVIF_IMAGE |TVIF_SELECTEDIMAGE |TVIF_TEXT|TVIF_STATE, "Friends List", FRIENDS_LIST_IMAGE_INDEX, FRIENDS_LIST_IMAGE_INDEX, TVIS_BOLD|TVIS_EXPANDED, TVIS_BOLD|TVIS_EXPANDED, NULL, NULL, TVI_FIRST); 
	m_pDoc->m_hOnline	= m_FriendsList.InsertItem(TVIF_CHILDREN|TVIF_HANDLE |TVIF_IMAGE |TVIF_SELECTEDIMAGE |TVIF_TEXT|TVIF_STATE, "Online Friends", ONLINE_FRIENDS_LIST_IMAGE_INDEX, ONLINE_FRIENDS_LIST_IMAGE_INDEX, TVIS_BOLD|TVIS_EXPANDED, TVIS_BOLD|TVIS_EXPANDED, NULL, m_pDoc->m_hFriends, TVI_FIRST);
	m_pDoc->m_hOffline	= m_FriendsList.InsertItem(TVIF_CHILDREN|TVIF_HANDLE |TVIF_IMAGE |TVIF_SELECTEDIMAGE |TVIF_TEXT|TVIF_STATE, "Offline Friends", OFFLINE_FRIENDS_LIST_IMAGE_INDEX, OFFLINE_FRIENDS_LIST_IMAGE_INDEX, TVIS_BOLD|TVIS_EXPANDED, TVIS_BOLD|TVIS_EXPANDED, NULL, m_pDoc->m_hFriends, TVI_LAST);
	m_pDoc->m_nNumOffline = m_pDoc->m_nNumOnline = 0;
}



/**************************************************************************/
// Method Name	: CreateASpeakWindow
// Description	: Called when creating a speak window for a friend
// Inputs		: Friend's name
//				  Message for the friend
//				  Font face
//				  Message font
//				  Font color
//				  Font size
// Output		: Finds out the speak window for the friend. If it's not there
//					creates a frame window, initializes it and sets it title with
//					the friend's name
//				  Sets focus on this speak window.
// Returns		: void
/**************************************************************************/
void CMessengerClientView::CreateASpeakWindow(CString& strFriend, char *strMessage,  CString& strFontFace, LOGFONT *pFont, int iFontColor, int iFontSize)
{
	CSpeakWindowFrame *pFrame;

	// If a window for this friend doesn't already exist
	if(!m_pDoc->FindSpeakDialogForFriend(strFriend))
	{
		// Get the document template
		CMultiDocTemplate *pDocTemplate = ((CMessengerClientApp *)::AfxGetApp())->pSpeakWindowDocTemplate;

		// Using this doc template, create a new frame window
		pFrame = (CSpeakWindowFrame *)((CMessengerClientApp *)::AfxGetApp())->pSpeakWindowDocTemplate->CreateNewFrame(m_pDoc, NULL);

		if(!pFrame)
		{
			::AfxMessageBox("Could not create speak window due to internal error");
			return;
		}

		pFrame->MoveWindow(SPEAK_WINDOW_X_POS, SPEAK_WINDOW_Y_POS
						   , SPEAK_WINDOW_WIDTH, SPEAK_WINDOW_HEIGHT + SPEAK_WINDOW_NON_CLIENT_AREA_HEIGHT);

		pFrame->InitialUpdateFrame(m_pDoc, true);
		pFrame->SetWindowText(strFriend + " -- Instant Message");

		// Put this window's address into doc
		m_pDoc->m_pSpeakDlg = (CSpeakWindow *)pFrame->GetActiveView();

		// Put doc's address into this window as its parent
		m_pDoc->m_pSpeakDlg->m_pParent = m_pDoc;

		// Fill in the From, To fields in the Speak dialog
		m_pDoc->m_pSpeakDlg->m_strFrom	= m_pDoc->m_UserName;
		m_pDoc->m_pSpeakDlg->m_strTo	= strFriend;

		// Adjust the font and font color on the speak dialog, if it's sent
		if(pFont)
		{
			// Get info abt current font
			if(!strFontFace.IsEmpty())		// If it's a valid font
			{
				m_pDoc->m_pSpeakDlg->SetTextFont(*pFont, strFontFace, m_pDoc->m_pSpeakDlg->m_ctrlWholeText, 0, 0, FORMAT_ALL_TEXT);
				m_pDoc->m_pSpeakDlg->m_iWholeTextFontColor = iFontColor;
				m_pDoc->m_pSpeakDlg->m_iWholeTextFontSize = iFontSize;
			}
		}

		// Get data from background vars to screen (From and To parties)
		m_pDoc->m_pSpeakDlg->UpdateData(FALSE);

		// Notify about this creation to the Doc class
		m_pDoc->m_SpeakDialogsList.AddTail(m_pDoc->m_pSpeakDlg);

		// Put the frame's address into speak window
		m_pDoc->m_pSpeakDlg->m_pFrame = pFrame;

		// Put main view class' address into Speak window
		m_pDoc->m_pSpeakDlg->m_pView = this;
	}	

	// Set the data in the dialog
	m_pDoc->m_pSpeakDlg->SetFocus();
	m_pDoc->m_pSpeakDlg->ShowWindow(SW_SHOW);
}



/**************************************************************************/
// Method Name	: OnAddFriend
// Description	: Called when user clicks Add a friend toolbar button or 
//					menu item.
// Inputs		: None
// Output		: Creates an Add Friend dialog and shows it.
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnAddFriend() 
{
	// Create a dialog fro adding a friend
	m_pDoc->m_pAddAFriendDlg = new CAddAFriend(m_pDoc, this);

	// Show this dialog modally
	m_pDoc->m_pAddAFriendDlg->DoModal();

	// Free the memory by this 
	delete(m_pDoc->m_pAddAFriendDlg);
	m_pDoc->m_pAddAFriendDlg = NULL;
}



/**************************************************************************/
// Method Name	: OnFileChangeUser
// Description	: Called when user clicks Change User / Login toolbar button or 
//					menu item.
// Inputs		: None
// Output		: If server is not running, shows error message
//				  Otherwise creates a Login dialog and shows it.
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnFileChangeUser() 
{
	CMessengerClientDoc *pDoc = (CMessengerClientDoc *)GetDocument();

	// If not connected
	if(!pDoc->m_bServerOnline)
	{
		// Try to connect to the server, in case it's started now
		if(!pDoc->ConnectToServer())
		{
			AfxMessageBox("Server is not running");
			return;
		}
	}

	// Show the messenger Dialog
	pDoc->m_pMessengerLoginDlg = new CMessengerDialog(pDoc, NULL);
	pDoc->m_pMessengerLoginDlg->m_bDoLogin = false;		// We do not do auto login thru this menu
	pDoc->m_pMessengerLoginDlg->DoModal();

	pDoc->m_pMessengerLoginDlg = NULL;
}



/**************************************************************************/
// Method Name	: OnOfflineMessages
// Description	: Called when user clicks Offline Messages menu item.
// Inputs		: None
// Output		: Calls method to create offline messages window
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnOfflineMessages() 
{
	// Create an offline messages dialog
	GetDocument()->CreateAnOfflineMessagesDialog();
}



/**************************************************************************/
// Method Name	: OnChangepassword
// Description	: Called when user clicks Change Password menu item.
// Inputs		: None
// Output		: Creates a Change Password dialog and shows it
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnChangepassword() 
{
	m_pDoc->m_pChangePasswordDlg = (CChangePassword *)new CChangePassword(m_pDoc);
	
	m_pDoc->m_pChangePasswordDlg->DoModal();

	// Free memory after dialog closed
	delete(m_pDoc->m_pChangePasswordDlg);
	m_pDoc->m_pChangePasswordDlg = NULL;
}



/**************************************************************************/
// Method Name	: UpdateMenuItem
// Description	: Called when user clicks any menu item to be enabled or
//					disabled depending on user's login status.
// Inputs		: System defined, Passed to this method by ON_UPDATE_COMMAND_UI
//					handlers of menus
// Output		: Enables menu item if user logged in
//				  Otherwise disables it
// Returns		: void
/**************************************************************************/
void CMessengerClientView::UpdateMenuItem(CCmdUI *pCmdUI)
{
	// If the user is logged in, enable the menu, else disable it
	if(GetDocument()->m_bLoggedInFlag == TRUE)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}



/**************************************************************************/
// The following methods are all ON_UPDATE_COMMAND_UI handlers for menu items
// These items need to be disabled when user is not logged in, and enabled
// when he is logged in.
/**************************************************************************/
void CMessengerClientView::OnUpdateToolsChangepassword(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}

void CMessengerClientView::OnUpdateAddFriend(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}

void CMessengerClientView::OnUpdateMessages(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}

void CMessengerClientView::OnUpdateFileDisconnect(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}

void CMessengerClientView::OnUpdateDeleteFriend(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}

void CMessengerClientView::OnUpdateSearchFriend(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}

void CMessengerClientView::OnUpdateMessage(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}

void CMessengerClientView::OnUpdateToolsBlockeduserslist(CCmdUI* pCmdUI) 
{
	UpdateMenuItem(pCmdUI);
}
/**************************************************************************/
// End ON_UPDATE_COMMAND_UI handlers for menu items
/**************************************************************************/



/**************************************************************************/
// Method Name	: OnFileDisconnect
// Description	: Called when user clicks Disconnect menu item
// Inputs		: None
// Output		: If user is connected, calls methods to disconnect and free memory,
//					then connects again, but remains logged off
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnFileDisconnect() 
{
	// If we are not connected, don't bother to go further
	if(!m_pDoc->m_bConnectedFlag)
		return;

	m_pDoc->DoCleanup();

	// Since logging off breaks our connection with the server, reconnect
	// But before that do some cleanup
	m_pDoc->DisconnectFromServer();
	m_pDoc->ConnectToServer();
}



/**************************************************************************/
// Method Name	: OnDeleteFriend
// Description	: Called when user clicks Delete Friend
// Inputs		: None
// Output		: Shows Delete Friends dialog.
// Returns		: void
/**************************************************************************/
// If one chooses to delete a friend from the friend's list
void CMessengerClientView::OnDeleteFriend() 
{
	// Create a delete friends dialog
	m_pDoc->m_DeleteFriendsDlg = new CDeleteFriendsDlg(m_pDoc);

	// Show this dialog in modal fashion
	m_pDoc->m_DeleteFriendsDlg->DoModal();

	// Free memory after dialog closed
	delete(m_pDoc->m_DeleteFriendsDlg);
	m_pDoc->m_DeleteFriendsDlg = NULL;
}



/**************************************************************************/
// Method Name	: OnUpdateFileChangeUser
// Description	: Used to update the text of first menu item under File menu
//					This is done on ON_UPDATE_COMMAND_UI message
// Inputs		: System defined
// Output		: If user is logged in, shows Menu item as Change User
//					else shows Menu item as Login
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnUpdateFileChangeUser(CCmdUI* pCmdUI) 
{
	// If the user is logged in, enable the menu, else disable it
	if(GetDocument()->m_bLoggedInFlag == TRUE)
		pCmdUI->SetText("&Change User");
	else
		pCmdUI->SetText("&Login");
}



/**************************************************************************/
// Method Name	: OnFilePreferences
// Description	: Called when user pressed Preferences toolbar button or
//					menu item
// Inputs		: None
// Output		: Shows Preferences dialog
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnFilePreferences() 
{
	// Show the messenger Dialog
	m_pDoc->m_pPreferencesDlg = new CPreferences("Chatter-jee Preferences", m_pDoc);
	m_pDoc->m_pPreferencesDlg->DoModal();

	delete(m_pDoc->m_pPreferencesDlg);
	m_pDoc->m_pPreferencesDlg = NULL;
}



/**************************************************************************/
// Method Name	: SetBackgroundColor
// Description	: Method to change the background color of the Friend's tree view
// Inputs		: New color
// Output		: Changes background color of the tree view
// Returns		: void
/**************************************************************************/
void CMessengerClientView::SetBackgroundColor(COLORREF &color)
{
	// Set this color as background color for the friend's window
	m_FriendsList.SetBkColor(color);
}



/**************************************************************************/
// Method Name	: CallOnFileChangeUser
// Description	: Interface method to allow calling of OnFileChangeUser()
//					from other objects, because OnFileChangeUser() is a 
//					protected method
// Inputs		: None
// Output		: Calls OnFileChangeUser()
// Returns		: void
/**************************************************************************/
void CMessengerClientView::CallOnFileChangeUser()
{
	OnFileChangeUser();
}



/**************************************************************************/
// Method Name	: OnUpdate
// Description	: Called by System to view update
// Inputs		: System defined
// Output		: Sets the background color of friend's list tree view
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if(lHint)
	{
		if(GetDocument()->m_Preferences.m_iColor)
			m_FriendsList.SetBkColor(m_pDoc->m_Preferences.m_iColor);
	}
}



/**************************************************************************/
// Method Name	: OnMessage
// Description	: Called when user clicks Send Message menu item or 
//					clicks the toolbar button
// Inputs		: None
// Output		: Creates a speak window
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnMessage() 
{
	// Create a speak dialog
	CreateASpeakWindow(m_strSelFriend, NULL, m_pDoc->m_Preferences.m_strFontFace, &m_pDoc->m_Preferences.m_Font, m_pDoc->m_Preferences.m_iFontColor, m_pDoc->m_Preferences.m_iFontSize);
}



/**************************************************************************/
// Method Name	: OnSelchangedOnline
// Description	: Called when user single clicks a tree item in friends list
//					tree view
// Inputs		: System defined
// Output		: If user clicked a heading, set selected name to ""
//				  If user selected a friend's name, set that name as selected name
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnSelchangedOnline(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	// Get the handle to the selected item
	HTREEITEM selFriend = m_FriendsList.GetSelectedItem();

	// If this is not an online friend's name, return
	int nImage = 0, nSelectedImage = 0;
	if(m_FriendsList.GetItemImage(selFriend, nImage, nSelectedImage))
	{
		if((nImage != ONLINE_FRIEND_IMAGE_INDEX) && (nImage != OFFLINE_FRIEND_IMAGE_INDEX))
		{
			m_strSelFriend = "";
			return;
		}
	}
	
	// If user has clicked a friend's name, store that name
	m_strSelFriend = m_FriendsList.GetItemText(selFriend);
	
	*pResult = 0;
}



/**************************************************************************/
// Method Name	: AdjustFormControls
// Description	: Method to maintain the aspect ratio and relative distances 
//					of various controls on the form
// Inputs		: None
// Output		: Adjust the form elements according to their design and 
//					relative sizes on the form.
//				  Sets the flag indicating this form has been resized at
//					least once.
// Returns		: void
/**************************************************************************/
void CMessengerClientView::AdjustFormControls()
{
	// These rects will contain the coordinates of speak window
	// and that of various controls
	CRect rectWin, rectFriendsTree;

	// Get main window's rects
	GetWindowRect(&rectWin);

	/****************************************************************************/
	// Position the "Friends List" tree control
	/****************************************************************************/

	// Adjust the tree's position below the label
	rectFriendsTree.left	= rectWin.left + BUFFER_DISTANCE;
	rectFriendsTree.top		= rectWin.top + (3 * BUFFER_DISTANCE);
	rectFriendsTree.right	= rectWin.right - BUFFER_DISTANCE;
	rectFriendsTree.bottom	= rectWin.bottom - BUFFER_DISTANCE;

	ScreenToClient(&rectFriendsTree);
	int ht = rectFriendsTree.Height();
	int wd = rectFriendsTree.Width();

	m_FriendsList.MoveWindow(rectFriendsTree.left, rectFriendsTree.top, wd, ht);

	// Set this var to false, because window is displayed once
	m_bFirstTime = false;
}



/**************************************************************************/
// Method Name	: OnSize
// Description	: Called when form is resized
// Inputs		: System defined - Type of resize, new width and height
// Output		: If this is the first time form is being resized,
//					adjust the form controls. If this check is not done,
//					program crashes!!
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	// Do this only if the window is resized after display
	if(!m_bFirstTime)
		// Resize controls appropriately and place them on proper positions
		AdjustFormControls();
}



/**************************************************************************/
// Method Name	: OnToolsBlockeduserslist
// Description	: Called when Tools-Blocked Users List menu item is clicked
// Inputs		: None
// Output		: Displays the blocked users list dialog
// Returns		: void
/**************************************************************************/
void CMessengerClientView::OnToolsBlockeduserslist() 
{
	// If blocked users list is not obtained, send a message packet to server
	// requesting the same
	if(!m_pDoc->m_bIsBlockedUsersListObtained)
	{
		CMessagePacket msg;
		msg.m_strFrom = m_pDoc->m_UserName;
		msg.m_strReasonFlag = "BUL";			
		m_pDoc->SendMessagePacket(msg);
		return;
	}
		
	// Create a blocked users list dialog and show in modal fashion
	CBlockedUsersListDlg dlg(m_pDoc);
	dlg.DoModal();
}
