//////////////////////////////////////////////////////////////////////
// MessengerClientView.h : interface of the CMessengerClientView class
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESSENGERCLIENTVIEW_H__30B8B552_B68A_11D6_8185_0001031200E7__INCLUDED_)
#define AFX_MESSENGERCLIENTVIEW_H__30B8B552_B68A_11D6_8185_0001031200E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AddAFriend.h"

class CMessengerClientView : public CFormView
{
protected: // create from serialization only
	CMessengerClientView();
	DECLARE_DYNCREATE(CMessengerClientView)

public:
	//{{AFX_DATA(CMessengerClientView)
	enum { IDD = IDD_MESSENGERCLIENT_FORM };
	CTreeCtrl	m_FriendsList;
	//}}AFX_DATA

// Attributes
public:
	CMessengerClientDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMessengerClientView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMessengerClientView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMessengerClientView)
	afx_msg void OnDblclkOnline(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAddFriend();
	afx_msg void OnFileChangeUser();
	afx_msg void OnOfflineMessages();
	afx_msg void OnChangepassword();
	afx_msg void OnUpdateToolsChangepassword(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAddFriend(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMessages(CCmdUI* pCmdUI);
	afx_msg void OnFileDisconnect();
	afx_msg void OnUpdateFileDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDeleteFriend(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSearchFriend(CCmdUI* pCmdUI);
	afx_msg void OnDeleteFriend();
	afx_msg void OnUpdateFileChangeUser(CCmdUI* pCmdUI);
	afx_msg void OnFilePreferences();
	afx_msg void OnMessage();
	afx_msg void OnSelchangedOnline(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnUpdateMessage(CCmdUI* pCmdUI);
	afx_msg void OnToolsBlockeduserslist();
	afx_msg void OnUpdateToolsBlockeduserslist(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	void CallOnFileChangeUser();
	void SetBackgroundColor(COLORREF& color);
	void InitFriendsList();
	CMessengerClientDoc *m_pDoc;
	virtual void CreateASpeakWindow(CString& strFriend, char *strMessage, CString& strFontFace, LOGFONT *pFont, int iFontColor, int iFontSize);
protected:
	bool m_bFirstTime;		// TRUE if the window has never been resized after display
	void AdjustFormControls();
	CString m_strSelFriend;
	void UpdateMenuItem(CCmdUI *pCmdUI);
};

#ifndef _DEBUG  // debug version in MessengerClientView.cpp
inline CMessengerClientDoc* CMessengerClientView::GetDocument()
   { return (CMessengerClientDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MESSENGERCLIENTVIEW_H__30B8B552_B68A_11D6_8185_0001031200E7__INCLUDED_)
