//////////////////////////////////////////////////////////////////////
// MessengerDialog.h: 
// interface for the CMessengerDialog class.
// User can login to the server using this dialog
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESSENGERDIALOG_H__30B8B55D_B68A_11D6_8185_0001031200E7__INCLUDED_)
#define AFX_MESSENGERDIALOG_H__30B8B55D_B68A_11D6_8185_0001031200E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MessengerDialog.h : header file
//

#include "MessengerClientDoc.h"
#include "PreferencesData.h"

class CRegisterDlg;

/////////////////////////////////////////////////////////////////////////////
// CMessengerDialog dialog

class CMessengerDialog : public CDialog
{
// Construction
public:
	CMessengerDialog(CWnd* pParent = NULL);   // standard constructor
	CMessengerDialog(CMessengerClientDoc *pDoc, CWnd* pParent = NULL);   // additional constructor

// Dialog Data
	//{{AFX_DATA(CMessengerDialog)
	enum { IDD = IDD_MESSENGER_DIALOG };
	CButton	m_btnOK;
	CString	m_UserName;
	CString	m_Password;
	BOOL	m_bAutoLogin;
	BOOL	m_bRememberLogin;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMessengerDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CMessengerDialog)
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnRegister();
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeUsername();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	CMessengerClientDoc *m_pParent;
	CRegisterDlg		*m_pRegisterDlg;
	virtual bool SendMessagePacket(CMessagePacket& msgPacket);
	int IsPasswordValid(CString password);
	bool m_bDoLogin;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MESSENGERDIALOG_H__30B8B55D_B68A_11D6_8185_0001031200E7__INCLUDED_)
