// Preferences.cpp : implementation file
//

#include "stdafx.h"
#include "MessengerClient.h"
#include "Preferences.h"
#include "MessengerClientDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPreferences

IMPLEMENT_DYNAMIC(CPreferences, CPropertySheet)

CPreferences::CPreferences(UINT nIDCaption, CMessengerClientDoc *pDoc, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	m_pParent = pDoc;

	// Copy preferences here
	m_Preferences = m_pParent->m_Preferences;

	AddMemberPages();
}

CPreferences::CPreferences(LPCTSTR pszCaption, CMessengerClientDoc *pDoc, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_pParent = pDoc;

	// Copy preferences here
	m_Preferences = m_pParent->m_Preferences;

	AddMemberPages();
}

CPreferences::~CPreferences()
{
}


BEGIN_MESSAGE_MAP(CPreferences, CPropertySheet)
	//{{AFX_MSG_MAP(CPreferences)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreferences message handlers



/**************************************************************************/
// Method Name	: AddMemberPages
// Description	: Called when creating this dialog
// Inputs		: None
// Output		: Adds the login preferences and font-color preferences pages to
//				  this dialog
// Returns		: void
/**************************************************************************/
void CPreferences::AddMemberPages()
{
	m_LoginPreferences.m_pParent = m_pParent;
	m_ColorFontsPreferences.m_pParent = m_pParent;

	AddPage(&m_LoginPreferences);
	AddPage(&m_ColorFontsPreferences);
}



/**************************************************************************/
// Method Name	: OnInitDialog
// Description	: Called when creating this dialog
// Inputs		: None
// Output		: Calls the base class method
//				  Copies application preferences in this dialog
// Returns		: TRUE	- Success
//				  FALSE - Otherwise
/**************************************************************************/
BOOL CPreferences::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();

	// Get preferences from doc object
	CPreferencesData preferences;
	preferences = m_pParent->m_Preferences;

	// Copy login preferences
	m_LoginPreferences.m_bAutoLogin		= preferences.m_bAutoLogin;
	m_LoginPreferences.m_bRememberLogin = preferences.m_bRememberLogin;
	m_LoginPreferences.m_strUserName	= preferences.m_UserName;
	m_LoginPreferences.m_strPassword	= preferences.m_Password;

	// Copy color and fonts preferences (Not needed)

	// Put these on the screen
	m_LoginPreferences.UpdateData(FALSE);
	
	return bResult;
}

