//////////////////////////////////////////////////////////////////////
// Preferences.h: 
// interface for the CPreferences class.
// This dialog combines both Login preferences and Color & Font preferences.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PREFERENCES_H__35BE9904_D093_11D6_819F_0001031200E7__INCLUDED_)
#define AFX_PREFERENCES_H__35BE9904_D093_11D6_819F_0001031200E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Preferences.h : header file
//

#include "LoginPreferences.h"
#include "ColorFontsPreferences.h"
#include "PreferencesData.h"

/////////////////////////////////////////////////////////////////////////////
// CPreferences

class CMessengerClientDoc;

class CPreferences : public CPropertySheet
{
	DECLARE_DYNAMIC(CPreferences)

// Construction
public:
	CPreferences(UINT nIDCaption, CMessengerClientDoc *pDoc, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CPreferences(LPCTSTR pszCaption, CMessengerClientDoc *pDoc, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPreferences)
	public:
	virtual BOOL OnInitDialog();
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPreferences();

	// Generated message map functions
protected:
	void AddMemberPages();
	//{{AFX_MSG(CPreferences)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	CMessengerClientDoc		*m_pParent;			// Doc object

	// Property pages
	CLoginPreferences		m_LoginPreferences;
	CColorFontsPreferences	m_ColorFontsPreferences;

	// All the preferences will be kept here
	CPreferencesData		m_Preferences;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PREFERENCES_H__35BE9904_D093_11D6_819F_0001031200E7__INCLUDED_)
