//////////////////////////////////////////////////////////////////////
// SpeakWindow.h: 
// interface for the CSpeakWindow class.
// This window helps user type his/her messages for friends and receive messages
// from them
// For each friend, one speak window is opened, when in conversation mode
// Each speak window has a copy of preferences, so that user can set different
// fonts etc for diff friends @ runtime
// SpeakWindow represents a form view and it uses CSpeakWindowFrame class as
// its frame window
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPEAKWINDOW_H__6E112EB0_DD2D_11D6_81A9_0001031200E7__INCLUDED_)
#define AFX_SPEAKWINDOW_H__6E112EB0_DD2D_11D6_81A9_0001031200E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SpeakWindow.h : header file
//
#include "MessagePacket.h"
#include "MessengerClientSocket.h"
#include "BlockedUserConfirmDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CSpeakWindow form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CMessengerClientDoc;
class CMessengerClientView;

class CSpeakWindow : public CFormView
{
protected:
	CSpeakWindow();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CSpeakWindow)

// Form Data
public:
	//{{AFX_DATA(CSpeakWindow)
	enum { IDD = IDD_SPEAKWINDOW_FORM };
	CButton	m_btnBackColor;
	CButton	m_btnFont;
	CEdit	m_ctrlTo;
	CButton	m_btnSend;
	CRichEditCtrl	m_ctrlWholeText;
	CRichEditCtrl	m_ctrlTypedText;
	CString	m_strFrom;
	CString	m_strTo;
	CString	m_strTypedText;
	CString	m_strWholeText;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSpeakWindow)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CSpeakWindow();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSpeakWindow)
	afx_msg void OnSend();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnFont();
	afx_msg void OnBackcolor();
	afx_msg void OnFileNew();
	afx_msg void OnFileSend();
	afx_msg void OnFileClose();
	afx_msg void OnFormatFont();
	afx_msg void OnFormatColor();
	afx_msg void OnFormatDefaultfontandcolor();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditDelete();
	afx_msg void OnEditSelectall();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveas();
	afx_msg void OnFileBlockthisuser();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	void AddTextToWholeText(CMessagePacket &msg);
	int m_iWholeTextFontColor;
	int m_iWholeTextFontSize;
	CMessengerClientDoc *m_pParent;
	bool m_bNewSpeakWindow;	// true if no text is there in the window
	LOGFONT	m_WholeTextFont;
	void SetTextFont(LOGFONT& font, CString& strFontFace, CRichEditCtrl& control, int iFontColor, int iFontSize, int iHowMuchText);
	CSpeakWindowFrame *m_pFrame;		// Corresponding frame window
	CMessengerClientView *m_pView;		// Main view class

	// Preferences
	CPreferencesData	m_Preferences;

	// Dirty status
	bool m_bDirty;

	// Saved status
	bool m_bSavedOnce;

	// File name to be saved as
	CString m_strFileName;

protected:
	void DoSaving();
	void SetControlsBackColor(int iColor);
	HICON m_hFontButtonIcon;
	CPoint m_ToolBarPosition;
	void AdjustFormControls();
	void InitCharFormat(CHARFORMAT& format);
	void GetCurrentFont(CMessagePacket& msg);
	bool m_bFirstTime;		// TRUE if the window has never been resized after display
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPEAKWINDOW_H__6E112EB0_DD2D_11D6_81A9_0001031200E7__INCLUDED_)
