// SpeakWindowFrame.cpp : implementation file
//

#include "stdafx.h"
#include "MessengerClient.h"
#include "MessengerClientDoc.h"
#include "SpeakWindowFrame.h"
#include "SpeakWindow.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpeakWindowFrame

IMPLEMENT_DYNCREATE(CSpeakWindowFrame, CFrameWnd)

CSpeakWindowFrame::CSpeakWindowFrame()
{
}

CSpeakWindowFrame::~CSpeakWindowFrame()
{
}


BEGIN_MESSAGE_MAP(CSpeakWindowFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CSpeakWindowFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpeakWindowFrame message handlers

BOOL CSpeakWindowFrame::DestroyWindow() 
{
	// Tell the parent's document that this dialog is closing. This will enable
	// the Doc class to remove this dialog from the open dialogs list
	CSpeakWindow *view = (CSpeakWindow *)GetActiveView();
	view->m_pParent->RemoveSpeakDialogFromList(view->m_strTo);
	
	return CFrameWnd::DestroyWindow();
}



/**************************************************************************/
// Method Name	: OnCreateClient
// Description	: Calld when initializing
// Inputs		: System defined
// Output		: Creates toolbar
//				  Initializes view pointer
//				  Calls base class method
// Returns		: TRUE - Success
//				  FALSE - Failure
//				  -1 - Toolbar creation failed
/**************************************************************************/
BOOL CSpeakWindowFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// Create a toolbar
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		//!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		!m_wndToolBar.LoadToolBar(IDR_SPEAKDLG_TOOLBAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// We want to align toolbar to the middle, so do this enabling
	m_wndToolBar.EnableDocking(CBRS_ALIGN_RIGHT);
	
	// Enable docking of toolbar on any side of frame
	EnableDocking(CBRS_ALIGN_ANY);

	m_pView = (CSpeakWindow *)GetActiveView();

	return CFrameWnd::OnCreateClient(lpcs, pContext);
}
